image: node:8.12-alpine

stages:
  - lint
  - test
  - deploy:prod

variables:
  AWS_DEFAULT_REGION: eu-central-1

cache:
  paths:
    - node_modules/

test:node:8:
  image: node:8.12-alpine
  cache:
    paths:
      - node_modules/
  script:
    - npm install
    - npm run lint
    - npm run test:unit
  coverage: /Lines\s*:\s*(\d+\.{0,1}\d*)\%/


.deploy: &deploy
  script:
    - npm install -g serverless
    - sls deploy

deploy:prod:
  stage: deploy:prod
  variables:
    AWS_ACCESS_KEY_ID: $AWS_ACCESS_KEY_ID
    AWS_SECRET_ACCESS_KEY: $AWS_SECRET_ACCESS_KEY
    ENV: prod
  only:
    - /^\d+\.\d+\.\d+$/ # e.g. 1.0.0
    - master
  <<: *deploy
